/* cloner.h
 * Author: Daniel Karrels dan@karrels.com
 */

#ifndef __CLONER_H
#define __CLONER_H "$Id: cloner.h,v 1.1.1.1 2002/05/11 05:36:54 customlinux Exp $"

#include	<string>
#include	<vector>

#include	<ctime>

#include	"client.h"
#include	"iClient.h"
#include	"iServer.h"

using std::string ;
using std::vector ;

namespace euworld
{

class cloner : public xClient
{

public:
	cloner( const string& configFileName ) ;
	virtual ~cloner() ;

	virtual int OnConnect() ;
	virtual int OnPrivateMessage( iClient*, const string& ) ;
	virtual void addClone() ;

protected:

	virtual string		randomNick( int minLength = 3,
					int maxLength = 9 ) ;
	virtual string		randomUser() ;
	virtual string		randomHost() ;
	virtual string		randomMode() ;
	virtual char		randomChar() ;

	vector< iClient* >	clones ;
	vector< string >	userNames ;
	vector< string >	hostNames ;
	iServer*		fakeServer ;

	string			cloneDescription ;

} ;

} // namespace euworld

#endif // __CLONER_H
